import greenfoot.*;  // (World, Actor, GreenfootImage, Greenfoot and MouseInfo)
import java.awt.Color;
/**
 * Write a description of class Powers here.
 * 
 * @author (your name) 
 * @version (a version number or a date)
 */
public class Powers extends Actor
{
    
    /** the radius of this powerup */
    private int radius = 7;
    
    /** the width of this powerup (diameter) */
    private int width = radius * 2;
    
    /** the color of the powerup */
    private Color color;
    
    /** the amount of change in x during each act */
    private int velX = 0;
    
    /** the amount of change in y during each act */
    private int velY = 4;
    
    /** the powerup index */
    int power;
    
    public Powers (World w, int x, int y)
    {
        w.addObject(this, x, y);
        int rand = Greenfoot.getRandomNumber(3);
        if (rand == 0)
            rand = Greenfoot.getRandomNumber(2)+3;
        else
            rand = Greenfoot.getRandomNumber(3);
        Color[] cs = {Color.DARK_GRAY,Color.ORANGE,Color.PINK,Color.WHITE,Color.BLUE,Color.GREEN.darker().darker()};
        power = rand;
        color = cs[rand];
        updateImage();
    }
    
    
    public void act() 
    {
        BreakoutWorld world = (BreakoutWorld) getWorld();
        setLocation(getX()+velX,getY()+velY);
        Actor a = getOneIntersectingObject(Paddle.class);
        int myY = getY();
        if (a != null)
        {
            this.getWorld().removeObject(this);
            Paddle p = (Paddle) a;
            if (power == 0)
            {
                p.changeWidth(p.getWidth()/2);
                world.message.setText(world.message.getText().substring(0,7) + "    Smaller Paddle!");
            }
            if (power == 1)
            {
                for (Ball b : world.bs)
                    b.changeSpeed((int)(b.getVX()*2), (int)(b.getVY()*2));
                world.message.setText(world.message.getText().substring(0,7) + "    Double Speed!");
            }
            if (power == 2)
            {
                p.invertControl(true);
                world.message.setText(world.message.getText().substring(0,7) + "    Inverted Paddle Control!");
            }
            if (power == 3)
            {
                for (Ball b : ((BreakoutWorld)getWorld()).bs)
                    b.changeSpeed((int)(b.getVX()*.5+1), (int)(b.getVY()*.5)+1);
                world.message.setText(world.message.getText().substring(0,7) + "    Slower Ball!");
            }
            if (power == 4)
            {
                p.changeWidth((int)(p.getWidth()*1.5));
                world.message.setText(world.message.getText().substring(0,7) + "    Bigger Paddle!");
            }
            if (power == 5)
            {
                for (Ball b : ((BreakoutWorld)getWorld()).bs)
                    b.turnFire(true);
                world.message.setText(world.message.getText().substring(0,7) + "    Fire Balls!");
            }
            
        }
        if (myY>=world.getHeight()-radius)
        {
            // revmoe the ball from the world
            world.removeObject(this);
        }
        
    }
    public void updateImage()
    {
        GreenfootImage image = new GreenfootImage(width,width);
        image.setColor(color);
        image.fillOval(0,0,width,width);
        setImage(image);
    }
}
